{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup.yml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/FO",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/KS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PI",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/SM",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/forward_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/reverse_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/bam",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ]
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/readgroup_meta",
                    "type": "#readgroup.yml/readgroup_meta"
                }
            ],
            "expression": "${\n  var output = { \"fastq\": inputs.fastq,\n                 \"readgroup_meta\": inputs.readgroup_meta};\n  output.fastq.format = \"edam:format_2182\";\n  return {'output': output}\n}\n",
            "id": "#emit_readgroup_fastq_se_file.cwl",
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_se_file"
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastq_cleaner:428dc9a83e62a74c61d8a5fe907f5d75154f862dc47b755b0f7cfdf1cfd66668"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil(1.1 * inputs.fastq.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(1.1 * inputs.fastq.size / 1048576))",
                    "outdirMin": "$(Math.ceil(1.1 * inputs.fastq.size / 1048576))",
                    "outdirMax": "$(Math.ceil(1.1 * inputs.fastq.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastq_cleaner_se.cwl/fastq",
                    "type": "File",
                    "format": "#fastq_cleaner_se.cwl/format_2182",
                    "inputBinding": {
                        "prefix": "--fastq"
                    }
                },
                {
                    "id": "#fastq_cleaner_se.cwl/reads_in_memory",
                    "type": "long",
                    "default": 500000,
                    "inputBinding": {
                        "prefix": "--reads_in_memory"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastq_cleaner_se.cwl/cleaned_fastq",
                    "type": "File",
                    "format": "#fastq_cleaner_se.cwl/format_2182",
                    "outputBinding": {
                        "glob": "$(inputs.fastq.basename)"
                    }
                },
                {
                    "id": "#fastq_cleaner_se.cwl/result_json",
                    "type": "File",
                    "format": "#fastq_cleaner_se.cwl/format_3464",
                    "outputBinding": {
                        "glob": "result.json"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastq_cleaner"
            ],
            "id": "#fastq_cleaner_se.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/json-to-sqlite:439b1b7f41fedc927859177a8073ac8b9ab8179b9c474fc274ac415d95b6eb7c"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 10,
                    "tmpdirMax": 10,
                    "outdirMin": 10,
                    "outdirMax": 10
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#json_to_sqlite.cwl/input_json",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--input_json"
                    }
                },
                {
                    "id": "#json_to_sqlite.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                },
                {
                    "id": "#json_to_sqlite.cwl/table_name",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--table_name"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#json_to_sqlite.cwl/sqlite",
                    "format": "#json_to_sqlite.cwl/format_3621",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid).db"
                    }
                },
                {
                    "id": "#json_to_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid).log"
                    }
                }
            ],
            "baseCommand": [
                "json_to_sqlite"
            ],
            "id": "#json_to_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                }
            ],
            "class": "Workflow",
            "inputs": [
                {
                    "id": "#main/input",
                    "type": "#readgroup.yml/readgroup_fastq_se_file"
                },
                {
                    "id": "#main/job_uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#main/output",
                    "type": "#readgroup.yml/readgroup_fastq_se_file",
                    "outputSource": "#main/emit_readgroup_fastq_se_file/output"
                },
                {
                    "id": "#main/sqlite",
                    "type": "File",
                    "outputSource": "#main/json_to_sqlite/sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#main/fastq_cleaner_se",
                    "run": "#fastq_cleaner_se.cwl",
                    "in": [
                        {
                            "id": "#main/fastq_cleaner_se/fastq",
                            "source": "#main/input",
                            "valueFrom": "$(self.fastq)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastq_cleaner_se/cleaned_fastq"
                        },
                        {
                            "id": "#main/fastq_cleaner_se/result_json"
                        }
                    ]
                },
                {
                    "id": "#main/emit_readgroup_fastq_se_file",
                    "run": "#emit_readgroup_fastq_se_file.cwl",
                    "in": [
                        {
                            "id": "#main/emit_readgroup_fastq_se_file/fastq",
                            "source": "#main/fastq_cleaner_se/cleaned_fastq"
                        },
                        {
                            "id": "#main/emit_readgroup_fastq_se_file/readgroup_meta",
                            "source": "#main/input",
                            "valueFrom": "$(self.readgroup_meta)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_readgroup_fastq_se_file/output"
                        }
                    ]
                },
                {
                    "id": "#main/json_to_sqlite",
                    "run": "#json_to_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/json_to_sqlite/input_json",
                            "source": "#main/fastq_cleaner_se/result_json"
                        },
                        {
                            "id": "#main/json_to_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        },
                        {
                            "id": "#main/json_to_sqlite/table_name",
                            "valueFrom": "fastq_cleaner_se"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/json_to_sqlite/sqlite"
                        },
                        {
                            "id": "#main/json_to_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
